(*
  (DelphiScript)
     OpenOffice Calc
: SmaLL
e-mail: oman@list.ru

     8.5.2.2  2007
   8.5.3.0  2008

 :
    " "
         
  .
      .

:
  1.         , , :
    sql\install.sql
  1.   
  2.   
  3.   "ExportToOpenOffice"    , 
         OpenOffice Calc.

        ,
   http://smallweb.narod.ru/pages/program/Editor.exe

:
          ""
  
History
~~~~~~~~~~~~~~~~~~~~~~~
16.07.2008
:
  -      
  -           
  -         

04.07.2008
:
  -        ( -()- )

02.07.2008
:
  -    ( ())

25.04.2008
:
  -    :  ,  

23.04.2008
  
 
*)


//  -   
function _GetParams(var aToExport): boolean;
var
  frm: TForm;
  btnOK, btnCancel: TButton;
  rgpParams: TRadioGroup;
  modalRes: Integer;
  dbgrid: TDBGrid;
begin
  aToExport:= 1;
  Result:= False;

  frm := TForm.Create(Application);
  try
    with frm do
    begin
      Position := poScreenCenter;
      BorderStyle := bsDialog;
      Height := 200;
      Width := 200;
      Caption := ' ';
    end;

    rgpParams := TRadioGroup.Create(frm);
    with  rgpParams do
    begin
      Parent := frm;
      Height := 70;
      Align := alTop;
      Caption := '   ';
      TabOrder := 0;
      Items.Text := ' '#13#10' ';
      if GetDocumentCount > 1 then
        ItemIndex := 0
      else
        ItemIndex := 1;
    end;

    btnOK := TButton.Create(frm);
    with btnOK do
    begin
      Parent := frm;
      Height := 25;
      Width := 75;
      Left := frm.ClientWidth- Width - Width - 8;
      Top := frm.ClientHeight - Height - 4;
      Caption := 'OK';
      TabOrder := 1;
      btnOK.Default:= True;
      ModalResult := mrOk;
    end;

    btnCancel := TButton.Create(frm);
    with btnCancel do
    begin
      Parent := frm;
      Height := 25;
      Width := 75;
      Left := frm.ClientWidth- Width - 4;
      Top := frm.ClientHeight - Height - 4;
      Caption := '';
      TabOrder := 2;
      ModalResult := mrCancel;
      Cancel := True;
    end;

    modalRes:= frm.ShowModal;

    if modalRes = mrOk then
    begin
      aToExport:= rgpParams.ItemIndex;
      Result:= True;
    end;

  finally
    frm.Free;
  end;
end;

//   -    
function _GetAggregateField(aDS: TDataset; aCol: TColumn):string;
var Delim, Str: string;
 li;
begin
      //   
      Result:= '';
      //   
      if aCol.AggregateFields.Count = 0 then Exit;
      Delim:= Chr(aCol.AggregateDelimiter);

      //     
      if aCol.AggregateType = 1 //atAccountNumber
      then Delim:= '.';

      for li:= 0 to aCol.AggregateFields.Count-1 do
      begin
        if (aCol.AggregateFields[li] = 'FAKE') or (UpperCase(aCol.AggregateFields[li]) = '@SCURRENCY') then Continue;
//        Str:= Trim(aDS.FieldByName(aCol.AggregateFields[li]).AsString);
        Str:= Trim(aDS.FieldByName(StringReplace(aCol.AggregateFields[li], '@', '', MkSet(rfReplaceAll, rfIgnoreCase))).AsString);
        if Str <> '' then
          Result:= Result + Str +Delim;
      end;
      if (Result = '') or VarIsNull(Result) then
        Exit;
      //    ,  
      if Result[Length(Result)] = Delim then
        Result:= Copy(Result, 1, Length(Result)-1);
end;

//         
procedure _InsertDocLine(aSheet, aGrid, aDS, aLine, acalcFields);
var li, lCol, lCell, lFld, lValue;

  function _GetYesNo(aValue);
  begin
    case aValue of
      0:  Result: = '';
      1:  Result: = '';
    end;
  end;

begin
    for li := 0 to aGrid.Columns.Count - 1 do
    begin
      lCol := aGrid.Columns.Items[li];
      lCell := aSheet.getCellByPosition(li, aLine);
     // ShowMessage(lCol.FieldName);

      //   ,   . 
      if lCol.AggregateType <> 0 then
        lCell.setString(_GetAggregateField(aDS, lCol))
      else
      begin
        try
          lFld := aDS.FieldByName(lCol.FieldName);
        except
          Continue;
        end;
        //   
        if VarIsNull(lFld.Value) or (lFld.Value = Null) then
        begin
          // ShowMessage('null - '+lCol.FieldName);
          Continue;
        end;

        //       
        if lFld.ClassNameIs('TFloatField') then
          lCell.setValue(lFld.AsFloat)
        else
        if lFld.ClassNameIs('TIntegerField') or
          lFld.ClassNameIs('TLargeintField') or
          lFld.ClassNameIs('TWordField') or lFld.ClassNameIs('TSmallIntField')
        then
          lCell.setValue(lFld.AsFloat)
        else
        if lFld.ClassNameIs('TSQLTimeStampField') or
          lFld.ClassNameIs('TDateTimeField') or
          lFld.ClassNameIs('TDateField') then
        begin
          //   
          if Length(lFld.AsString) > 0 then
          begin
            lCell.NumberFormat := 36; //  :  01.01.2008
            lCell.setValue(lFld.AsDateTime);
            // ShowMessage(''+Fld.AsString+' - '+Col.FieldName);
          end;
        end
        else
          lCell.setString(lFld.AsString);
      end;// if

      //   
      //      acalcFields,    
      if Pos(UpperCase(lCol.FieldName), acalcFields) > 0 then
      begin
//        ShowMessage(lCol.FieldName+'/'+lFld.AsString);
        Query.Close;
        Query.ParamByName('FIELD_NAME').asString := lCol.FieldName;
        Query.ParamByName('FIELD_VALUE').AsString := lFld.AsString;
        Query.Open;
//        ShowMessage(Query.FieldByName('FIELD_RESULT').AsString);
        if not Query.IsEmpty then
          lCell.setString(Query.FieldByName('FIELD_RESULT').AsString);
        Query.Close;
      end;
    end;  // for

end; //procedure


//   
procedure ExportToOpenOffice;
var
  OpenOffice: Variant;
  OpenDesktop: Variant;
  Document: Variant;
  Sheets, Sheet : Variant;
  Frm, Grid, i, j: Variant;
  Cell,Col : Variant;
  DS: Variant;
  str: Variant;
  Fld: Variant;
//  selected: Variant;
  located: Boolean;
  ToExport: Variant;
  calcFields: String;

begin
//  ShowMessage(UnitCode);

  ToExport:= -1;
  if not _GetParams(ToExport) then Exit;
//  ShowMessage(IntToStr(ToExport));

  OpenOffice := Null;
  //   OpenOffice
  if OpenOffice = Null then
    OpenOffice := CreateOleObject('com.sun.star.ServiceManager');
  if (VarIsEmpty(OpenOffice) or VarIsNull(OpenOffice)) then
  begin
    ShowMessage('    OpenOffice.');
    Exit;
  end;

  //  
  OpenDesktop := OpenOffice.CreateInstance('com.sun.star.frame.Desktop');

  //  -   Calc
  Document := OpenDesktop.LoadComponentFromURL('private:factory/scalc',
    '_blank', 0, VarArrayCreate([0, -1], varVariant));

  if (VarIsEmpty(Document) or VarIsNull(Document)) then
  begin
    ShowMessage('  !');
    Exit;
  end;

  //    -  
  Document.lockControllers;
  Document.addActionLock;

  try
    //  
    //  Frm := Application.MainForm.ActiveMDIChild;
    Frm := Screen.ActiveForm;
    //   - 
    Grid := Frm.ActiveControl;

    //   
    Sheets := Document.GetSheets;
    // 1 
    Sheet := Sheets.getByIndex(0);

    //  
    Sheet.Name := '';

    if Grid.Name = 'MasterGrid' then
      //  
      Sheet.Name := StringReplace(Frm.MasterTitlePanel.Caption, ':', '_', MkSet(rfReplaceAll, rfIgnoreCase));

    if Grid.Name = 'SlaveGrid' then
      //  
      Sheet.Name := StringReplace(Frm.DetailTitlePanel.Caption, ':', '_', MkSet(rfReplaceAll, rfIgnoreCase));

    //   -  
    for i := 0 to Grid.Columns.Count - 1 do
    begin
      Cell := Sheet.getCellByPosition(i, 0);
      str := Grid.Columns.Items[i].Caption + '('+Grid.Columns.Items[i].FieldName+')';
//      Grid.Columns.Items[i].Caption := Grid.Columns.Items[i].Caption + '('+Grid.Columns.Items[i].FieldName+')';
      Cell.CharWeight:= 150;
      Cell.setString(str);
    end;
    // 
  {   for i:= 0 to Grid.Columns.Count-1 do
     begin
       Cell := Sheet.getCellByPosition(i, 1);
       str:= Grid.Columns.Items[i].FieldName;
       Cell.setString(str);
     end; }

    //  
    DS := Grid.Datasource.Dataset;

    //   
    Query.Close;
    Query.SQL.Text:= 'select distinct '+
                            'T.FIELD_NAME '+
                            'from A_V_CALCFIELDS T '+
                            'where T.UNITCODE = '''+UnitCode+'''';
    Query.Open;
    if not Query.IsEmpty then
    begin
      //        (  )
      Query.First;
      calcFields:= '';
      while not Query.EOF do
      begin
        calcFields:= calcFields+';'+Query.FieldByName('FIELD_NAME').AsString;
        Query.Next;
      end;
      Query.Close;
      calcFields:= UpperCase(calcFields);
      //      
      Query.SQL.Text:= 'select T.FIELD_RESULT ' +
                          'from A_V_CALCFIELDS T ' +
                         'where T.UNITCODE = :UNITCODE ' +
                           'and T.FIELD_NAME = :FIELD_NAME ' +
                           'and T.FIELD_VALUE = :FIELD_VALUE';
      Query.ParamByName('UNITCODE').Value := UNITCODE;
    end
    else
      Query.Close;

    //  
    if ToExport = 0 then
    begin
      // 
      for i:= 0 to GetDocumentCount - 1 do
      begin
        located:= DS.Locate(DS.KeyField, GetDocument(i), Null);
        if located then
          _InsertDocLine(Sheet, Grid, DS, i+1, calcFields);
      end;
    end
    else
    begin
      //    
      DS.First;
      j := 1;
      while not DS.EOF do
      begin
        _InsertDocLine(Sheet, Grid, DS, j, calcFields);
        j := j + 1;
        DS.Next;
      end;
      DS.First;
    end;

  finally
    //   
    Document.unLockControllers;
    Document.removeActionLock;
    Frm:= Null;
    Query.Close;
  end;
end;

